# visier.sdk.api.model-query
Visier APIs for querying data and model metadata

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 22222222.99201.1411
- Package version: 0.0.3
- Generator version: 7.7.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import visier.sdk.api.model_query
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import visier.sdk.api.model_query
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import visier.sdk.api.model_query
from visier.sdk.api.model_query.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = visier.sdk.api.model_query.Configuration(
    host = "http://localhost"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: CookieAuth
configuration.api_key['CookieAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['CookieAuth'] = 'Bearer'

# Configure API key authorization: ApiKeyAuth
configuration.api_key['ApiKeyAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['ApiKeyAuth'] = 'Bearer'

configuration.access_token = os.environ["ACCESS_TOKEN"]

configuration.access_token = os.environ["ACCESS_TOKEN"]

# Configure Bearer authorization: BearerAuth
configuration = visier.sdk.api.model_query.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with visier.sdk.api.model_query.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = visier.sdk.api.model_query.DataModelApi(api_client)
    id = 'id_example' # str | The ID of the analytic object to retrieve metrics for.

    try:
        # Retrieve a list of metrics for an analytic object by ID
        api_response = api_instance.analytic_metrics(id)
        print("The response of DataModelApi->analytic_metrics:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DataModelApi->analytic_metrics: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DataModelApi* | [**analytic_metrics**](docs/DataModelApi.md#analytic_metrics) | **GET** /v1/data/model/analytic-objects/{id}/metrics | Retrieve a list of metrics for an analytic object by ID
*DataModelApi* | [**analytic_object**](docs/DataModelApi.md#analytic_object) | **GET** /v1/data/model/analytic-objects/{id} | Retrieve an analytic object by ID
*DataModelApi* | [**analytic_objects**](docs/DataModelApi.md#analytic_objects) | **GET** /v1/data/model/analytic-objects | Retrieve a list of analytic objects
*DataModelApi* | [**call_property**](docs/DataModelApi.md#call_property) | **GET** /v1/data/model/analytic-objects/{objectId}/properties/{id} | Retrieve a property by ID
*DataModelApi* | [**currencies**](docs/DataModelApi.md#currencies) | **GET** /v1/data/model/currencies | Retrieve all currencies
*DataModelApi* | [**currency**](docs/DataModelApi.md#currency) | **GET** /v1/data/model/currencies/{id} | Retrieve a currency
*DataModelApi* | [**currency_rates**](docs/DataModelApi.md#currency_rates) | **GET** /v1/data/model/currencies/{id}/rates | Retrieve all exchange rates for a currency
*DataModelApi* | [**currency_rates_with_to_currency**](docs/DataModelApi.md#currency_rates_with_to_currency) | **GET** /v1/data/model/currencies/{id}/rates/{toId} | Retrieve exchange rates from one currency to another currency
*DataModelApi* | [**dimension**](docs/DataModelApi.md#dimension) | **GET** /v1/data/model/analytic-objects/{objectId}/dimensions/{id} | Retrieve a dimension by ID
*DataModelApi* | [**dimension_member_map_validation**](docs/DataModelApi.md#dimension_member_map_validation) | **POST** /v1/data/model/analytic-objects/{objectId}/dimensions/{dimensionId}/mappings/validate | Validate a member map&#39;s unmapped dimension members by ID
*DataModelApi* | [**dimensions**](docs/DataModelApi.md#dimensions) | **GET** /v1/data/model/analytic-objects/{objectId}/dimensions | Retrieve a list of dimensions
*DataModelApi* | [**member**](docs/DataModelApi.md#member) | **GET** /v1/data/model/analytic-objects/{objectId}/dimensions/{dimensionId}/members/{id} | Retrieve a dimension member
*DataModelApi* | [**members**](docs/DataModelApi.md#members) | **GET** /v1/data/model/analytic-objects/{objectId}/dimensions/{dimensionId}/members | Retrieve a list of dimension members
*DataModelApi* | [**metric**](docs/DataModelApi.md#metric) | **GET** /v1/data/model/metrics/{id} | Retrieve a metric by ID
*DataModelApi* | [**metric_dimensions**](docs/DataModelApi.md#metric_dimensions) | **GET** /v1/data/model/metrics/{metricId}/dimensions | Retrieve a metric&#39;s dimensions
*DataModelApi* | [**metric_selection_concepts**](docs/DataModelApi.md#metric_selection_concepts) | **GET** /v1/data/model/metrics/{metricId}/selection-concepts | Retrieve a metric&#39;s selection concepts
*DataModelApi* | [**metrics**](docs/DataModelApi.md#metrics) | **GET** /v1/data/model/metrics | Retrieve a list of metrics
*DataModelApi* | [**planning_metrics**](docs/DataModelApi.md#planning_metrics) | **GET** /v1/data/model/plan-models/{id}/metrics | Retrieve metrics by planning model ID
*DataModelApi* | [**planning_model**](docs/DataModelApi.md#planning_model) | **GET** /v1/data/model/plan-models/{id} | Retrieve a planning model by ID
*DataModelApi* | [**planning_models**](docs/DataModelApi.md#planning_models) | **GET** /v1/data/model/plan-models | Retrieve a list of planning models
*DataModelApi* | [**planning_plan**](docs/DataModelApi.md#planning_plan) | **GET** /v1/data/model/plan-models/{modelId}/plans/{id} | Retrieve a plan by ID
*DataModelApi* | [**planning_plans**](docs/DataModelApi.md#planning_plans) | **GET** /v1/data/model/plan-models/{modelId}/plans | Retrieve a list of plans
*DataModelApi* | [**prediction**](docs/DataModelApi.md#prediction) | **GET** /v1/data/model/predictions/{id} | Retrieve a prediction by ID
*DataModelApi* | [**predictions**](docs/DataModelApi.md#predictions) | **GET** /v1/data/model/predictions | Retrieve a list of predictions
*DataModelApi* | [**properties**](docs/DataModelApi.md#properties) | **GET** /v1/data/model/analytic-objects/{objectId}/properties | Retrieve a list of properties
*DataModelApi* | [**selection_concept**](docs/DataModelApi.md#selection_concept) | **GET** /v1/data/model/analytic-objects/{objectId}/selection-concepts/{id} | Retrieve an analytic object&#39;s selection concept by ID
*DataModelApi* | [**selection_concepts**](docs/DataModelApi.md#selection_concepts) | **GET** /v1/data/model/analytic-objects/{objectId}/selection-concepts | Retrieve an analytic object&#39;s selection concepts
*QueryApi* | [**aggregate**](docs/QueryApi.md#aggregate) | **POST** /v1/data/query/aggregate | Query aggregate data
*QueryApi* | [**list**](docs/QueryApi.md#list) | **POST** /v1/data/query/list | Query a list of details
*QueryApi* | [**snapshot**](docs/QueryApi.md#snapshot) | **POST** /v1/data/query/snapshot | Query a series of detailed snapshots
*QueryApi* | [**sql_like**](docs/QueryApi.md#sql_like) | **POST** /v1/data/query/sql | Query aggregate or list data using SQL-like syntax


## Documentation For Models

 - [AggregationQueryDTO](docs/AggregationQueryDTO.md)
 - [AggregationQueryExecutionDTO](docs/AggregationQueryExecutionDTO.md)
 - [AggregationQuerySourceDTO](docs/AggregationQuerySourceDTO.md)
 - [AggregationQuerySourceMetricDTO](docs/AggregationQuerySourceMetricDTO.md)
 - [AggregationQuerySourceMetricsDTO](docs/AggregationQuerySourceMetricsDTO.md)
 - [AggregationTypeOptionDTO](docs/AggregationTypeOptionDTO.md)
 - [AggregationTypeParameterDTO](docs/AggregationTypeParameterDTO.md)
 - [AggregationTypeParameterValueDTO](docs/AggregationTypeParameterValueDTO.md)
 - [AnalyticObjectDTO](docs/AnalyticObjectDTO.md)
 - [AnalyticObjectsDTO](docs/AnalyticObjectsDTO.md)
 - [CellDTO](docs/CellDTO.md)
 - [CellDistributionBinDTO](docs/CellDistributionBinDTO.md)
 - [CellDistributionOptionsDTO](docs/CellDistributionOptionsDTO.md)
 - [CellSetAxisDTO](docs/CellSetAxisDTO.md)
 - [CellSetAxisPositionDTO](docs/CellSetAxisPositionDTO.md)
 - [CellSetDTO](docs/CellSetDTO.md)
 - [CohortFilterDTO](docs/CohortFilterDTO.md)
 - [CurrenciesDTO](docs/CurrenciesDTO.md)
 - [CurrencyDTO](docs/CurrencyDTO.md)
 - [CurrencyRateDTO](docs/CurrencyRateDTO.md)
 - [CurrencyRatesDTO](docs/CurrencyRatesDTO.md)
 - [DimensionDTO](docs/DimensionDTO.md)
 - [DimensionMappingValidationDTO](docs/DimensionMappingValidationDTO.md)
 - [DimensionMappingValidationExecutionDTO](docs/DimensionMappingValidationExecutionDTO.md)
 - [DimensionMemberReferenceDTO](docs/DimensionMemberReferenceDTO.md)
 - [DimensionReferenceDTO](docs/DimensionReferenceDTO.md)
 - [DimensionsDTO](docs/DimensionsDTO.md)
 - [GoogleProtobufAny](docs/GoogleProtobufAny.md)
 - [InternalQueryExecutionOptionsDTO](docs/InternalQueryExecutionOptionsDTO.md)
 - [KeyGroupFilterDTO](docs/KeyGroupFilterDTO.md)
 - [KeyGroupFilterItemDTO](docs/KeyGroupFilterItemDTO.md)
 - [LevelDTO](docs/LevelDTO.md)
 - [LineageDTO](docs/LineageDTO.md)
 - [ListQueryExecutionDTO](docs/ListQueryExecutionDTO.md)
 - [ListQueryExecutionOptionsDTO](docs/ListQueryExecutionOptionsDTO.md)
 - [ListQuerySourceDTO](docs/ListQuerySourceDTO.md)
 - [ListResponse](docs/ListResponse.md)
 - [MemberDTO](docs/MemberDTO.md)
 - [MemberFilterDTO](docs/MemberFilterDTO.md)
 - [MemberParameterDefinitionDTO](docs/MemberParameterDefinitionDTO.md)
 - [MemberParameterValueDTO](docs/MemberParameterValueDTO.md)
 - [MemberValuesDTO](docs/MemberValuesDTO.md)
 - [MembersDTO](docs/MembersDTO.md)
 - [MetricDTO](docs/MetricDTO.md)
 - [MetricsDTO](docs/MetricsDTO.md)
 - [NumericParameterDefinitionDTO](docs/NumericParameterDefinitionDTO.md)
 - [NumericParameterValueDTO](docs/NumericParameterValueDTO.md)
 - [ObjectReferenceDTO](docs/ObjectReferenceDTO.md)
 - [ParameterDefinitionDTO](docs/ParameterDefinitionDTO.md)
 - [PlanParameterDefinitionDTO](docs/PlanParameterDefinitionDTO.md)
 - [PlanParameterValueDTO](docs/PlanParameterValueDTO.md)
 - [PlanningConceptFilterContextDTO](docs/PlanningConceptFilterContextDTO.md)
 - [PlanningHierarchyFilterContextDTO](docs/PlanningHierarchyFilterContextDTO.md)
 - [PlanningModelDTO](docs/PlanningModelDTO.md)
 - [PlanningModelsDTO](docs/PlanningModelsDTO.md)
 - [PlanningPlanContextDTO](docs/PlanningPlanContextDTO.md)
 - [PlanningPlanDTO](docs/PlanningPlanDTO.md)
 - [PlanningPlansDTO](docs/PlanningPlansDTO.md)
 - [PopulationConfigurationDTO](docs/PopulationConfigurationDTO.md)
 - [PredictionDTO](docs/PredictionDTO.md)
 - [PredictionsDTO](docs/PredictionsDTO.md)
 - [PropertiesDTO](docs/PropertiesDTO.md)
 - [PropertyColumnDTO](docs/PropertyColumnDTO.md)
 - [PropertyDTO](docs/PropertyDTO.md)
 - [PropertyReferenceDTO](docs/PropertyReferenceDTO.md)
 - [QueryAxisDTO](docs/QueryAxisDTO.md)
 - [QueryAxisOptionsDTO](docs/QueryAxisOptionsDTO.md)
 - [QueryDimensionDataMemberSelectionDTO](docs/QueryDimensionDataMemberSelectionDTO.md)
 - [QueryDimensionLeafSelectionDTO](docs/QueryDimensionLeafSelectionDTO.md)
 - [QueryDimensionLevelSelectionDTO](docs/QueryDimensionLevelSelectionDTO.md)
 - [QueryDimensionMemberSelectionDTO](docs/QueryDimensionMemberSelectionDTO.md)
 - [QueryExecutionOptionsDTO](docs/QueryExecutionOptionsDTO.md)
 - [QueryFilterDTO](docs/QueryFilterDTO.md)
 - [QueryMemberMapPropertyDTO](docs/QueryMemberMapPropertyDTO.md)
 - [QueryMemberMapSelectionDTO](docs/QueryMemberMapSelectionDTO.md)
 - [QueryNumericRangesDTO](docs/QueryNumericRangesDTO.md)
 - [QueryParameterValueDTO](docs/QueryParameterValueDTO.md)
 - [QueryPropertyDTO](docs/QueryPropertyDTO.md)
 - [QueryTimeIntervalDTO](docs/QueryTimeIntervalDTO.md)
 - [QueryTimeIntervalsDTO](docs/QueryTimeIntervalsDTO.md)
 - [ScenarioOrSnapshotDTO](docs/ScenarioOrSnapshotDTO.md)
 - [SelectionConceptDTO](docs/SelectionConceptDTO.md)
 - [SelectionConceptReferenceDTO](docs/SelectionConceptReferenceDTO.md)
 - [SelectionConceptsDTO](docs/SelectionConceptsDTO.md)
 - [SnapshotQueryExecutionDTO](docs/SnapshotQueryExecutionDTO.md)
 - [SnapshotQueryExecutionOptionsDTO](docs/SnapshotQueryExecutionOptionsDTO.md)
 - [SortOptionDTO](docs/SortOptionDTO.md)
 - [SqlLikeQueryExecutionDTO](docs/SqlLikeQueryExecutionDTO.md)
 - [Status](docs/Status.md)
 - [TagMapElementDTO](docs/TagMapElementDTO.md)
 - [TimeShiftDTO](docs/TimeShiftDTO.md)
 - [ValidityRangeDTO](docs/ValidityRangeDTO.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="ApiKeyAuth"></a>
### ApiKeyAuth

- **Type**: API key
- **API key parameter name**: apikey
- **Location**: HTTP header

<a id="BearerAuth"></a>
### BearerAuth

- **Type**: Bearer authentication

<a id="CookieAuth"></a>
### CookieAuth

- **Type**: API key
- **API key parameter name**: VisierASIDToken
- **Location**: 

<a id="OAuth2Auth"></a>
### OAuth2Auth

- **Type**: OAuth
- **Flow**: password
- **Authorization URL**: 
- **Scopes**: 
 - **read**: Grants read access
 - **write**: Grants write access

<a id="OAuth2Auth"></a>
### OAuth2Auth

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: /v1/auth/oauth2/authorize
- **Scopes**: 
 - **read**: Grants read access
 - **write**: Grants write access


## Author




